import { objAssign, randomCode, tableAction } from "@/plugins/utils";
// mixins
import commonMixins from "../mixins/common";
import privilegeMixins from "../mixins/privilege";
// components
import ViewFooter from "@/components/ViewFooter.vue";
import MoreText from "@/components/MoreText.vue";
import CourseSelect from "../components/base/CourseSelect.vue";
import SchoolSelect from "../components/base/SchoolSelect.vue";
import SemesterSelect from "../components/base/SemesterSelect.vue";
import CollegeSelect from "../components/base/CollegeSelect.vue";
import ClazzSelect from "../components/base/ClazzSelect.vue";
import MajorSelect from "../components/base/MajorSelect.vue";
import ClassSelect from "../components/base/ClassSelect.vue";
import ExamSelect from "../components/base/ExamSelect.vue";
import OrgSelect from "../components/base/OrgSelect.vue";

const components = {
  ViewFooter,
  MoreText,
  CourseSelect,
  SchoolSelect,
  SemesterSelect,
  CollegeSelect,
  ClazzSelect,
  MajorSelect,
  ClassSelect,
  ExamSelect,
  OrgSelect
};

export default {
  install: function(Vue) {
    // 实例方法
    Vue.prototype.$tableAction = tableAction;
    Vue.prototype.$objAssign = objAssign;
    Vue.prototype.$randomCode = randomCode;

    // 注册全局组件
    Object.keys(components).forEach(key => {
      Vue.component(key, components[key]);
    });

    //全局 mixins
    Vue.mixin(commonMixins);
    Vue.mixin(privilegeMixins);
  }
};
